#include "knock_module.h"

unsigned int recorded_seq[MAX_KNOCKS];

unsigned int to_validate_index = 0;
unsigned int to_validate_seq[MAX_KNOCKS];

unsigned long int start_time_freerun = -1;

bool is_valid_knock(int pos)
{
	return to_validate_seq[pos] + 1 == recorded_seq[pos] ||
			to_validate_seq[pos] - 1 == recorded_seq[pos] || 
			to_validate_seq[pos] == recorded_seq[pos];
}

void listen_knock(void) 
{
	if (is_valid_knock()) {
		unsigned long int now;
		
		if(to_validate_index == 0)
			start_time_freerun = get_time();
		
		now = get_time();
		/* Turn on the blue LED */
		PORTD |= (1 << PD7); 
		
		to_validate_seq[to_validate_index++] = (now - start_time_freerun) / 1000;
		
		start_time_freerun = get_time();
		
		_delay_ms(FADE_TIME);
		/* Turn off the blue LED */
		PORTD &= ~(1 << PD7);
		
		if(to_validate_index == MAX_KNOCKS)
		{
			unsigned int i;
		
			for(i = 1; i < MAX_KNOCKS; i++)
				if(!is_valid_knock(i))
				{
					i = MAX_KNOCKS + 10;
					flash_blue(5);
					servo_set_lock_position();
					
					_delay_ms(FADE_TIME);
					
					break;
				}
			
			if(i != MAX_KNOCKS + 10)
			{
				flash_green(5);
				servo_set_unlock_position();
				if ((PIND & (1 << PD4)) == 0) {
					_delay_ms(500);
					servo_set_lock_position();
					for(i = 0; i < MAX_KNOCKS; i++)
						to_validate_seq[i] = -1;
				
					to_validate_index = 0;
				}

				_delay_ms(FADE_TIME);
			}
			
			for(i = 0; i < MAX_KNOCKS; i++)
				to_validate_seq[i] = -1;
				
			to_validate_index = 0;
		}
		
		_delay_ms(FADE_TIME);	
	} 
}

void program_knock(void)
{
	int i = 0;
	unsigned long int now, start_time;
	
	start_time = get_time();
	
	while (i < MAX_KNOCKS) {
		
		if (is_valid_knock()) {
			now = get_time();
			/* Turn on the blue LED */
			PORTD |= (1 << PD7);
			
			recorded_seq[i++] = (now - start_time) / 1000;
			
			start_time = get_time();
			
			_delay_ms(FADE_TIME);
			/* Turn off the blue LED */
			PORTD &= ~(1 << PD7);
			
		}
	}
	flash_green(7);
}
