#include "led.h"

/*
 * Initializes both LEDs
 */
void LED_init(void)
{
	/* Sets the PC0 pin (green led) as output */
	DDRC |= (1 << PC0);
	
	/* Sets the PD7 pin (blue led) as output */
	DDRD |= (1 << PD7);
}

/*
 * Flashes the green LED to signal succes
 *
 * @param num - number of flashes
 */
void flash_green(int num)
{
	int i;
	
	for(i = 0; i < num; i++) {
		_delay_ms(FADE_TIME);
		PORTC &= ~(1 << PC0);
		_delay_ms(FADE_TIME);
		PORTC |= (1 << PC0);
	}
}

/*
 * Flashes the blue LED to signal succes
 *
 * @param num - number of flashes
 */
void flash_blue(int num)
{
	int i;
	
	for(i = 0; i < num; i++) {
		_delay_ms(FADE_TIME);
		PORTD &= ~(1 << PD7);
		_delay_ms(FADE_TIME);
		PORTD |= (1 << PD7);
	}
}
