#include "servo.h"

/*
 * Initializes the micro servo
 */
void servo_init(void)
{
	/* Sets the PD5 pin as output */
	DDRD |= (1 << PD5);
	
	/* Non-Inverted PWM */
	TCCR1A |= (1 << COM1A1) | (1 << COM1B1) | (1 << WGM11);
	
	/* Prescaler = 64 - Mode 14 (Fast PWM) */
	TCCR1B |= (1 << WGM13) | (1 << WGM12) | (1 << CS11) | (1 << CS10);

	/* fPWM = 50Hz - Period = 20ms Standard */
	ICR1 = 4999;
}

/*
 * Sets the position of the micro servo to locked
 */
void servo_set_lock_position(void)
{
	OCR1A = 136;
}

/*
 * Sets the position of the micro servo to unlocked
 */
void servo_set_unlock_position(void)
{
	OCR1A = 375;
	//OCR1A = -136;
}
