#include "timer.h"

volatile unsigned int long global_time;

/*
 * Increments the global time on interrupt
 */
ISR(TIMER0_COMPA_vect)
{
	global_time++;
}

/*
 * Initializes the timer
 */
void timer_init(void)
{
	TCCR0A |= (1 << WGM01);
	TCCR0B |= (1 << CS01);
	
	TIMSK0 |= (1 << OCIE0A);
	
    OCR0A = CTC_MATCH_OVERFLOW;
	
	sei();
}

/*
 * Gets the current milliseconds elapsed from initialization
 */
unsigned long get_time(void)
{
    unsigned long millis_return;

    ATOMIC_BLOCK(ATOMIC_FORCEON) {
        millis_return = global_time;
    }
 
    return millis_return;
}
