#ifndef _VIBRATION_SENSOR_H_
#define _VIBRATION_SENSOR_H_

/*
 * LD-BZPN-1705 buzzer
 */

#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>

#include "usart.h"

#define AREF 5
#define THRESHOLD 0.1
#define MAX_KNOCKS 6

/*
 * Initializes the Analog-Digital Converter
 */
void ADC_init(void);

/*
 * Returns true if the voltage from the channel
 * is greater that a THRESHOLD
 */
bool is_valid_knock(void);

/*
 * Prints the current value to serial
 * Used for debug purposes
 */
void ADC_print(void);

#endif // _VIBRATION_SENSOR_H_
